Status: Closed Start date: 08 Nov 2011

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: CoCoA-4 function: obsolete Estimated time: 2.50 hours

Target version: CoCoA-5.1.1 Seoul14 Spent time: 2.55 hours

Description

In CoCoA-5 there was a function called "Call"

(apply a function to given arguments)

called like this   ;-)

  MyMax(Function("LT_Standard"),3,5);

Now it is pointless because we can call directly "LT_Standard(3,5);"

instead of calling it with "Call"   (having fun ;-)    

Moreover in CoCoA-5 there is no function called "Function" to call  (hahaha)

Now the serious question: should we keep "Call" for backward compatibility?

2014-08 Final decision: OBSOLETE

Related issues:

Related to CoCoA-5 - Design #532: New package: OBSOLESCENT Closed 09 Apr 2014

History

#1 - 08 Nov 2011 15:37 - Anna Maria Bigatti

- Category set to CoCoA-4 function: obsolete

#2 - 08 Nov 2011 15:51 - John Abbott

JAA opposes the proposal because he thinks that it is no longer needed now that we have functions as first class objects (and he also thinks that Call

was an ugly appendage).  He is willing to be persuaded otherwise if a reasonable example can be found where Call produces a neater solution than

using a first-class function value.

The lack of backward compatibility is unlikely to be a serious problem because Call was used only rarely (e.g. 6 times in the C4 packages).

#3 - 10 Nov 2011 17:10 - John Abbott

The Call function is used when running the C4 tests.  Not sure how easy it will be to rewrite the code which runs the tests if Call is not available --

needs investigation.

#4 - 15 Nov 2011 12:50 - Anna Maria Bigatti

John Abbott wrote:

The Call function is used when running the C4 tests.  Not sure how easy it will be to rewrite the code which runs the tests if Call is not available

-- needs investigation.

 

The only call I found in packages/ts/ is in DoTests which is not called.
I believe also other calls in the packages can be updated. (crossing fingers)

#5 - 01 Mar 2012 16:05 - John Abbott

- % Done changed from 0 to 50

Based on the premise "It is easier to add features later than to remove them", JAA suggests that we do not offer a Call function similar to that in C4.

If a genuine need for such a function arises then we can reconsider the question (but I doubt that the need will ever arise).

#6 - 01 Mar 2012 16:10 - John Abbott

A find-grep shows that Call appears in the following files:

cocoa5.cpkg

contrib/CantStop.cpkg

contrib/thmproving.cpkg

list.cpkg

man/help.cpkg

monomial_ideals.cpkg

ts/ts_lib.cpkg

Anna, could you very that all these uses can be easy replaced by other code in C5 (or even removed altogether).

#7 - 02 Apr 2014 17:33 - Anna Maria Bigatti

- Target version set to CoCoA-5.1.0 Easter14

#8 - 09 Apr 2014 17:47 - John Abbott

- Target version changed from CoCoA-5.1.0 Easter14 to CoCoA-5.1.1 Seoul14

#9 - 28 Jul 2014 17:01 - Anna Maria Bigatti

- Assignee set to Anna Maria Bigatti

- Estimated time set to 2.50 h

It is now officially documented as OBSOLETE, so I close this issue.

#10 - 01 Sep 2014 15:47 - John Abbott

- Status changed from New to Closed

- % Done changed from 50 to 100

Apparently this has already been done (but Anna forgot to "close" properly).
